
   // Set FSM variable 
    
    function setFSMVariable(varname, value)
    {
    
		console.debug("Set FSM variable: " + varname + " to value " + value);  
	 	
		try
		{
			var pass_data = {
	    		indexPath: indexPath,
	    		userDefIdPath: userDefIdPath,
	    		microfinEvent: 'resetEvent',
	        	microfinVariable: { variableName: varname, newValue: value },	
				traceMessage: { 
					action: 'sending FSM event ' + event,
				},
	    		traceCount : traceCount++
			};
	
			window.parent.postMessage(JSON.stringify(pass_data), '*');	
		} 
		catch(e) {
			console.debug(e); 
		}	
    }
	      
	// Send a trace message
	 
	function postLogEvent(message)
	{
	 	console.debug("Trace Message: " + message); 
	 
	 	try
		{
			var pass_data = {
	    		indexPath: indexPath,
	    		userDefIdPath: userDefIdPath, 
				traceMessage: { 
					action: message,
				},
	    		traceCount : traceCount++
			};
	
			window.parent.postMessage(JSON.stringify(pass_data), '*');	
		} 
		catch(e) {
			console.debug(e); 
		}
		
	}
	
	// Trigger an fsm event (e.g., to end the item)
	
	function postFsmEvent(event)
	{
	 	console.debug("FSM Event: " + event);  
	 	
		try
		{
			var pass_data = {
	    		indexPath: indexPath,
	    		userDefIdPath: userDefIdPath,
	    		microfinEvent: event,
				traceMessage: { 
					action: 'sending FSM event ' + event,
				},
	    		traceCount : traceCount++
			};
	
			window.parent.postMessage(JSON.stringify(pass_data), '*');	
		} 
		catch(e) {
			console.debug(e); 
		}
	}
	
	// Restore the page from a previously stored state as string, e.g., XML/JSON
	
	function setState(stateString) {
	    try {
	        console.debug("Set State: " + stateString); 
	        createStage (JSON.parse(stateString));
	    } 
	    catch (e) {
	        console.debug(e); 
	    }
	}
	
	// Save the state of the page as string (e.g., XML/JSON)
	 
	function getState() {
	    try {
	        console.debug("Get State");
	        var json = JSON.stringify(items);
	        return json;
	    } 
	    catch (e) {
	        console.debug(e); 
	    }
	}
	
	// Helper
	
	function getQueryVariable(variable)
	{
		const parsedUrl = new URL(window.location.href);
		return parsedUrl.searchParams.get(variable);
	}
	  
	var indexPath = getQueryVariable('indexPath');
	var userDefIdPath = getQueryVariable('userDefIdPath');
	  
	// Trace Counter
	
	var traceCount = 0;